
from LIB.MIDDLE.FaultClass.V1_0_0.faultclass import *
import pymysql
import datetime
import pandas as pd
from LIB.BACKEND import DBManager
dbManager = DBManager.DBManager()
from sqlalchemy import create_engine
from urllib import parse
import datetime, time
from apscheduler.schedulers.blocking import BlockingScheduler
import traceback
import pickle
from keras.models import load_model
import logging
import logging.handlers
import os
import re


#...................................故障检测函数......................................................................................................................
def diag_cal():
    global SNnums
    global list_faults,list_scalers,list_models,list_cols,list_time_steps,list_features

    start=time.time()
    now_time=datetime.datetime.now()
    start_time=now_time-datetime.timedelta(hours=1)
    start_time=start_time.strftime('%Y-%m-%d %H:%M:%S')
    end_time=now_time.strftime('%Y-%m-%d %H:%M:%S')

    #数据库配置
    host='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port=3306
    db='safety_platform'
    user='qx_read'
    password='Qx@123456'

    #读取结果库数据......................................................
    param='product_id,start_time,end_time,fault_class,update_time'
    tablename='fault_class'
    mysql = pymysql.connect (host=host, user=user, password=password, port=port, database=db)
    cursor = mysql.cursor()
    sql =  "select {} from {} where end_time='0000-00-00 00:00:00'".format(param,tablename)
    cursor.execute(sql)
    res = cursor.fetchall()
    df_diag_ram= pd.DataFrame(res,columns=param.split(','))

    db_res_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, parse.quote_plus(password), host, port, db
        ))

    #调用主函数................................................................................................................................................................
    for sn in SNnums:
        try:
            #sn='PK50001A100000248'
            #start_time='2022-11-18 00:00:00'
            #end_time='2022-11-18 03:00:00'
            group=sn[:2]
            if group in ['PK','MG','UD']:
                df_data = dbManager.get_data(sn=sn, start_time=start_time, end_time=end_time, data_groups=['bms'])
                data_bms = df_data['bms']
                data_bms['sn']=sn
                if len(data_bms)>0:
                    df_diag_ram_sn=df_diag_ram[df_diag_ram['product_id']==sn]
                    for i in range(len(list_faults)):
                        fault=list_faults[i]
                        df_diag_ram_sn_fault=df_diag_ram_sn[df_diag_ram_sn['fault_class']==fault]
                        if len(df_diag_ram_sn_fault)>0:
                            df_diag_ram_sn_fault.reset_index(drop=True,inplace=True)
                            df_diag_ram_sn_fault=df_diag_ram_sn_fault.iloc[0]
                        logger.info("SN: {} 数据开始预处理".format(sn))
                        if fault=='B板采样失效':
                            data_fea=features1(data_bms)
                        elif fault=='传感器_电芯NTC漂移':
                            data_fea=features2(data_bms)
                        else:
                            feas=list_features[i]
                            data_fea=features_filtre(data_bms,feas)
                        logger.info("SN: {} 数据开始模型预测".format(sn))
                        modeli=list_models[i]
                        scaleri=list_scalers[i]
                        coli=list_cols[i]
                        time_stepsi=list_time_steps[i]
                        df_res=pred(data_fea,modeli,scaleri,coli,end_time,time_stepsi)
                        res_new,res_update=arrange2(df_diag_ram_sn_fault,df_res,time_stepsi)
                        if len(res_update)>0:
                            cursor.execute("DELETE FROM fault_class WHERE end_time = '0000-00-00 00:00:00' and product_id='{}' and fault_class='{}'".format(sn,fault))
                            mysql.commit()
                            res_update.to_sql("fault_class",con=db_res_engine, if_exists="append",index=False)
                        res_new.to_sql("fault_class",con=db_res_engine, if_exists="append",index=False)
    
            # end=time.time()
            # print(end-start)  
                
        except Exception as e:
            logger.error(str(e))
            logger.error(traceback.format_exc())

    cursor.close()
    mysql.close()

#...............................................主函数起定时作用.......................................................................................................................
if __name__ == "__main__":
    
    # 日志
    log_path = 'log/'
    if not os.path.exists(log_path):
        os.makedirs(log_path)
    logger = logging.getLogger("main")
    logger.setLevel(logging.DEBUG)
    
     # 根据日期滚动(每天产生1个文件)
    fh = logging.handlers.TimedRotatingFileHandler(filename='{}/main_info.log'.format(log_path), when="D", interval=1, backupCount=30,
                                                    encoding="utf-8")
    formatter = logging.Formatter("%(asctime)s - %(name)s-%(levelname)s %(message)s")
    fh.suffix = "%Y-%m-%d_%H-%M-%S"
    fh.extMatch = re.compile(r"^\d{4}-\d{2}-\d{2}_\d{2}-\d{2}-\d{2}")
    fh.setFormatter(formatter)
    fh.setLevel(logging.INFO)
    logger.addHandler(fh)

    fh = logging.handlers.TimedRotatingFileHandler(filename='{}/main_error.log'.format(log_path), when="D", interval=1, backupCount=30,
                                                    encoding="utf-8")
    formatter = logging.Formatter("%(asctime)s - %(name)s-%(levelname)s %(message)s")
    fh.suffix = "%Y-%m-%d_%H-%M-%S"
    fh.extMatch = re.compile(r"^\d{4}-\d{2}-\d{2}_\d{2}-\d{2}-\d{2}")
    fh.setFormatter(formatter)
    fh.setLevel(logging.ERROR)
    logger.addHandler(fh)

    logger.info("pid is {}".format(os.getpid()))
    
    # # 更新sn列表
    host='rm-bp10j10qy42bzy0q7.mysql.rds.aliyuncs.com'
    port=3306
    db='qixiang_oss'
    user='qixiang_oss'
    password='Qixiang2021'
    conn = pymysql.connect(host=host, port=port, user=user, password=password, database=db)
    cursor = conn.cursor()
    cursor.execute("select sn, imei, add_time from app_device where status in (1,2,3)")
    res = cursor.fetchall()
    df_sn = pd.DataFrame(res, columns=['sn', 'imei', 'add_time'])
    df_sn = df_sn.reset_index(drop=True)
    conn.close();

    #用户输出参数数据库配置
    host0='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port0=3306
    db0='qx_cas'
    user0='qx_algo_rw'
    password0='qx@123456'

    #读取用户输出参数......................................................
    param='fault_name,class,time_steps,accuracy'
    tablename='faultclass_output1'
    mysql = pymysql.connect (host=host0, user=user0, password=password0, port=port0, database=db0)
    cursor = mysql.cursor()
    sql =  "select {} from {}".format(param,tablename)
    cursor.execute(sql)
    res = cursor.fetchall()
    list_param= pd.DataFrame(res,columns=param.split(','))
    list_param.reset_index(drop=True,inplace=True)

    #读取用户输入参数......................................................
    param0='fault_name,cols,col_key,compare,threshold_filtre,time_steps,nbr_features,nbr_neurons,nbr_class,batch_size,epochs,dropout,lr,activation,loss,threshold_accuracy'
    tablename0='faultclass_input'
    mysql0 = pymysql.connect (host=host0, user=user0, password=password0, port=port0, database=db0)
    cursor0 = mysql0.cursor()
    sql0 =  "select {} from {} ".format(param0,tablename0)
    cursor0.execute(sql0)
    res0 = cursor0.fetchall()
    list_param0= pd.DataFrame(res0,columns=param0.split(','))
    list_param0.reset_index(drop=True,inplace=True)
    
    SNnums = list(df_sn['sn'])
    
    # # 加载模型
    list_model=os.listdir('LIB/MIDDLE/FaultClass/V1_0_0/models')
    list_faults=[]
    list_scalers=[]
    list_models=[]
    list_cols=[]
    list_time_steps=[]
    list_features=[]
    for k in range(len(list_model)):
        fault_name=list_model[k][6:-3]
        list_faults.append(fault_name)
        scaler=pickle.load(open('LIB/MIDDLE/FaultClass/V1_0_0/scalers/scaler_'+fault_name+'.pkl','rb'))
        list_scalers.append(scaler)
        model=load_model('LIB/MIDDLE/FaultClass/V1_0_0/models/'+list_model[k])
        list_models.append(model)
        if fault_name=='B板采样失效':
            col=['B板采样失效','正常']
            time_steps=60
            feature=['feature1']
        elif fault_name=='传感器_电芯NTC漂移':
            col=['传感器_电芯NTC漂移','正常']
            time_steps=60
            feature=['feature2']
        else:
            col=eval(list_param.loc[list_param[list_param['fault_name']==fault_name].index,'class'].values[0])
            time_steps=list_param.loc[list_param[list_param['fault_name']==fault_name].index,'time_steps'].values[0]
            feature=eval(list_param0.loc[list_param0[list_param0['fault_name']==fault_name].index,'cols'].values[0])
        list_cols.append(col)
        list_time_steps.append(time_steps)
        list_features.append(feature)
    logger.info("模型加载完成")

    diag_cal()
    #定时任务.......................................................................................................................................................................
    scheduler = BlockingScheduler()
    scheduler.add_job(diag_cal, 'interval', hours=1)

    try:  
        scheduler.start()
    except Exception as e:
        scheduler.shutdown()
        logger.error(str(e))
        logger.error(traceback.format_exc())