from ctypes import Structure
from re import M
import pandas as pd
import numpy as np
import datetime
import time, datetime
import matplotlib.pyplot as plt
from pylab import*
from scipy.signal import savgol_filter
from scipy import interpolate
import os
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import BatParam
class cell_statistic:
    def __init__(self,sn,celltype,df_bms):  #参数初始化
        self.sn=sn
        self.celltype=celltype
        self.param=BatParam.BatParam(celltype)#鹏飞param中为BatParam，学琦为BatteryInfo
        self.df_bms=pd.DataFrame(df_bms)
        self.packcrnt=df_bms['总电流[A]']*self.param.PackCrntDec
        self.packvolt=df_bms['总电压[V]']
        self.bms_soc=df_bms['SOC[%]']
        self.bmstime= pd.to_datetime(df_bms['时间戳'], format='%Y-%m-%d %H:%M:%S')
        self.LookTab_OCV = self.param.LookTab_OCV
        self.LookTab_SOC = self.param.LookTab_SOC
        self.packcrnt_flg = self.param.PackCrntDec#判断充放电电流方向，一般放电为正，充电为负
        self.cellvolt_list=['单体电压'+str(x) for x in range(1,self.param.CellVoltNums+1)]
        self.celltemp_name=['单体温度'+str(x) for x in range(1,self.param.CellTempNums+1)]
        self.bmssta = df_bms['充电状态']
    #定义加权滤波函数..................................................................................................
    def moving_average(interval, windowsize):
        window = np.ones(int(windowsize)) / float(windowsize)
        re = np.convolve(interval, window, 'same')
        return re
    
#.............................................静置行为统计............................................................................
    def rest_sta(self):
        def clean_dead_value(series, num_dead_thresh):
            slide_list = [series.index[0]]
            slide_list_all = []
            for i in range(series.index[0],series.index[-1]):
                j = i + 1
                diff = series[j] - series[i]
                if diff == 0:
                    slide_list.append(j)
                else:
                    slide_list.clear()
                    slide_list.append(j)
                # print("slide_list:",slide_list)
                if len(slide_list) >= num_dead_thresh:
                    target_list = slide_list.copy()
                    slide_list_all.append(target_list)
            # print("slide_list_all:",slide_list_all)
            index= []  # 将找到的满足条件的index合并
            # 因为可能有前后包含的情况，只保留最长序列
            for i in range(len(slide_list_all) - 1):
                if set(slide_list_all[i]) < set(slide_list_all[i + 1]):
                    index.append(i)
            m = {i: element for i, element in enumerate(slide_list_all)}
            [m.pop(i) for i in index]
            # 将所有需要删除的行数合并
            # indexs_to_delete = []
            # for i in range(len(slide_list_all)):
            #     indexs_to_delete = list(set(indexs_to_delete).union(slide_list_all[i]))
            return list(m.values())
        start_time = time.time()
        df_sts_chrg_rt = pd.DataFrame(columns = ['sn', 'time_st', 'time_end', 'delta_time','soc_st', 'soc_sp', 'delta_soc', 'temp_st', 'temp_sp', 'meancrnt', 'sts_flg'])
        df_sts_dschrg = pd.DataFrame(columns = ['sn', 'time_st', 'time_end','delta_time', 'soc_st', 'soc_sp', 'delta_soc', 'temp_st', 'temp_sp', 'meancrnt', 'sts_flg'])
        df_sts_soc = pd.DataFrame(columns = ['sn', 'time_st', 'time_end','delta_time', 'soc_st', 'soc_sp', 'delta_soc', 'temp_st', 'temp_sp', 'meancrnt', 'sts_flg'])
        data_temp = self.df_bms
        data_temp = data_temp.dropna(axis = 0, how = 'any', subset = ['总电流[A]', 'SOC[%]'])#删除电流与SOC中的nan值
        data_temp.reset_index(inplace = True, drop = True)
        data = data_temp.copy()
        data['总电流[A]'] = self.param.PackCrntDec*data_temp['总电流[A]']#电流小于0为充电，大于0为放电
        data['crnt_flg'] = 0
        data.loc[data['总电流[A]'] > 0, 'crnt_flg'] = 1
        data.loc[data['总电流[A]'] < 0, 'crnt_flg'] = -1
        celltemp_name = self.celltemp_name#电芯温度数量
        # data.to_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\08合众算法开发\04放电统计\分析数据.csv',index=False,encoding='GB18030')
        #-------------------------------------------------------利用电流连续为0判断电池静置---------------------------------------------------------
        # rest_crnt = data.loc[data['总电流[A]'] == 0]#电流为0，判断电池静置
        if not data.empty:
            df_crnt_flg = data['crnt_flg']
            num_dead_thresh = 15#判断连续多少个数据为阈值
            # series = df.iloc[:,0]  #仅作为示例，如果是多列，可以进行循环
            indexs_to_delelte = clean_dead_value(df_crnt_flg, num_dead_thresh)#获得连续数据所在的行
            # print(indexs_to_delelte)
            rest_num = len(indexs_to_delelte)
            if rest_num > 0:#仅有一个连续数据时
                for splice_item in range(0, rest_num):#rest_num
                    df_data_temp = data.iloc[indexs_to_delelte[splice_item][0]:indexs_to_delelte[splice_item][-1]]#获得电流连续数据
                    df_soc_temp = df_data_temp['SOC[%]']
                    delta_soc = round((df_soc_temp.iloc[-1] - df_soc_temp.iloc[0]), 3)
                    df_time_temp = pd.to_datetime(df_data_temp['时间戳'])
                    delta_time = (df_time_temp.iloc[-1] - df_time_temp.iloc[0])/pd.Timedelta(1, 'hours')
                    if all(df_data_temp['crnt_flg'] == 0):#静置判断
                        if delta_time > 0.17:
                            rate = round(delta_soc/(100*delta_time), 2)
                            df_sts_chrg_rt_temp = pd.DataFrame({"sn":[self.sn],
                                                    "time_st":[df_time_temp.iloc[0]], "time_end":[df_time_temp.iloc[-1]], "delta_time":[delta_time],
                                                    "soc_st":[df_soc_temp.iloc[0]], "soc_sp":[df_soc_temp.iloc[-1]], "delta_soc":[delta_soc],
                                                    "temp_st":[str(list(df_data_temp[celltemp_name].iloc[0]))],
                                                    "temp_sp":[str(list(df_data_temp[celltemp_name].iloc[-1]))],
                                                    "meancrnt":[rate], "sts_flg":['0']})
                            df_sts_chrg_rt = df_sts_chrg_rt.append(df_sts_chrg_rt_temp)
                            df_sts_chrg_rt.reset_index(drop = True, inplace = True)
                    elif all(df_data_temp['crnt_flg'] == -1):#充电判断
                        if delta_time > 0.2:
                            rate_chrg = round(delta_soc/(100*delta_time), 2)
                            df_sts_chrg_rt_temp = pd.DataFrame({"sn":[self.sn],
                                                    "time_st":[df_time_temp.iloc[0]], "time_end":[df_time_temp.iloc[-1]], "delta_time":[delta_time],
                                                    "soc_st":[df_soc_temp.iloc[0]], "soc_sp":[df_soc_temp.iloc[-1]], "delta_soc":[delta_soc],
                                                    "temp_st":[str(list(df_data_temp[celltemp_name].iloc[0]))],
                                                    "temp_sp":[str(list(df_data_temp[celltemp_name].iloc[-1]))],
                                                    "meancrnt":[rate_chrg], "sts_flg":['-1']})
                            df_sts_chrg_rt = df_sts_chrg_rt.append(df_sts_chrg_rt_temp)
                            df_sts_chrg_rt.reset_index(drop = True, inplace = True)
            chrg_rest_len = len(df_sts_chrg_rt)
            df_data_time = pd.to_datetime(data['时间戳'])
            if chrg_rest_len > 0:
                for item in range(0, 1):
                    time_early = (df_sts_chrg_rt.loc[0, 'time_st'] - df_data_time.iloc[0])/pd.Timedelta(1, 'hours')
                    if time_early > 0.2:
                        index_early = data[df_data_time == df_sts_chrg_rt.loc[0, 'time_st']].index.tolist()[0]
                        df_data_early = data.iloc[0:index_early]
                        df_soc_dschrg = df_data_early['SOC[%]']
                        df_time_dschrg = pd.to_datetime(df_data_early['时间戳'])
                        delta_soc_dschrg = round((df_soc_dschrg.iloc[-1] - df_soc_dschrg.iloc[0]), 3)
                        rate_dschrg = round(delta_soc_dschrg/(100*time_early), 2)
                        df_sts_dschrg_temp = pd.DataFrame({"sn":[self.sn], 
                                                "time_st":[df_time_dschrg.iloc[0]], "time_end":[df_time_dschrg.iloc[-1]], "delta_time":[time_early],
                                                "soc_st":[df_soc_dschrg.iloc[0]], "soc_sp":[df_soc_dschrg.iloc[-1]], "delta_soc":[delta_soc_dschrg],
                                                "temp_st":[str(list(df_data_early[celltemp_name].iloc[0]))],
                                                "temp_sp":[str(list(df_data_early[celltemp_name].iloc[-1]))],
                                                "meancrnt":[rate_dschrg], "sts_flg":['1']})
                        df_sts_dschrg = df_sts_dschrg.append(df_sts_dschrg_temp)
                        df_sts_dschrg.reset_index(drop = True, inplace = True)
                for item in range(1, chrg_rest_len):
                    time_early = (df_sts_chrg_rt.loc[item, 'time_st'] - df_sts_chrg_rt.loc[item-1, 'time_end'])/pd.Timedelta(1, 'hours')
                    if time_early > 0.2:
                        index_early = df_data_time[df_data_time == df_sts_chrg_rt.loc[item - 1, 'time_end']].index.tolist()[0]
                        index_later = df_data_time[df_data_time == df_sts_chrg_rt.loc[item, 'time_st']].index.tolist()[0]
                        df_data_early = data.iloc[index_early:index_later]
                        df_soc_dschrg = df_data_early['SOC[%]']
                        df_time_dschrg = pd.to_datetime(df_data_early['时间戳'])
                        delta_soc_dschrg = round((df_soc_dschrg.iloc[-1] - df_soc_dschrg.iloc[0]), 3)
                        rate_dschrg = round(delta_soc_dschrg/(100*time_early), 2)
                        df_sts_dschrg_temp = pd.DataFrame({"sn":[self.sn], 
                                                "time_st":[df_time_dschrg.iloc[0]], "time_end":[df_time_dschrg.iloc[-1]], "delta_time":[time_early],
                                                "soc_st":[df_soc_dschrg.iloc[0]], "soc_sp":[df_soc_dschrg.iloc[-1]], "delta_soc":[delta_soc_dschrg],
                                                "temp_st":[str(list(df_data_early[celltemp_name].iloc[0]))],
                                                "temp_sp":[str(list(df_data_early[celltemp_name].iloc[-1]))],
                                                "meancrnt":[rate_dschrg], "sts_flg":['1']})
                        df_sts_dschrg = df_sts_dschrg.append(df_sts_dschrg_temp)
                        df_sts_dschrg.reset_index(drop = True, inplace = True)
            df_sts_soc = df_sts_chrg_rt.append(df_sts_dschrg)
            df_sts_soc = df_sts_soc.sort_values(by = 'time_st')
        end_time = time.time()
        print(end_time - start_time)
        if not df_sts_soc.empty:
            return df_sts_soc
        else:
            return pd.DataFrame()
